/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package library;

import static library.ClockSynchronisation.READ_BUFFER;
import static library.ClockSynchronisation.WRITE_BUFFER;

/**
 *
 * @author Ben
 */
public abstract class ExecutionContext
{
    private boolean deleted[] = new boolean[]{false,false}; 
    
    public ExecutionContext()
    {
        ClockSynchronisation.nextUpdateTaskList.add(this);
    }
    
    
    public void delete()
    {
        deleted[WRITE_BUFFER] = true;
    }
    
    
    void execute()
    {
        
        if(deleted[READ_BUFFER])
            return;
        
        run();    
        ClockSynchronisation.nextUpdateTaskList.add(this);
        
    }
    
    
    public abstract void run();
}
